#!/usr/bin/env python  
import roslib
import rospy
import tf
import time
import math

from geometry_msgs.msg import Twist, Pose2D

pose = Pose2D()
pose.x =0
pose.y =0
pose.theta = 0


def handle_pose(msg):
  br = tf.TransformBroadcaster()
  br.sendTransform((msg.x, msg.y, 0),
    tf.transformations.quaternion_from_euler(0, 0, msg.theta),
    rospy.Time.now(),"base_link","odom")

def handle_drive(msg):
  global pose
  turn = msg.angular.x * math.pi / 180
  pose.theta = pose.theta + turn
  if (msg.linear.x <0.0):
    print "Only pos values"
    msg.linear.x = 0.0
  pose.x = pose.x + math.cos(pose.theta) * msg.linear.x
  pose.y = pose.y + math.sin(pose.theta) * msg.linear.x
  br = tf.TransformBroadcaster()
  br.sendTransform((pose.x, pose.y, 0),
    tf.transformations.quaternion_from_euler(0, 0, pose.theta),
    rospy.Time.now(),"base_link","odom")



if __name__ == '__main__':
  rospy.init_node('fake_odom')
  rospy.Subscriber('/fake_nav/pose', Pose2D, handle_pose)
  rospy.Subscriber('/fake_nav/drive', Twist, handle_drive)
  #send initial transform
  time.sleep(1)
  handle_pose(pose)
  time.sleep(1)
  handle_pose(pose)
  rospy.spin()
