#!/usr/bin/python

# uses imu data from ROS Sensor Messages (android) and
# publishes to fake_odom node (fake_nav/drive topic

import rospy, roslib, sys
from geometry_msgs.msg import Twist
from sensor_msgs.msg import Imu

def callback(imu_data):
  move = Twist()
  move.angular.x=0
  move.linear.x=0
  if ( imu_data.linear_acceleration.y < -0.5 ): 
    move.linear.x = imu_data.linear_acceleration.y * -1 / 10.0 / 120.0
  if (imu_data.linear_acceleration.x < -0.5) or (imu_data.linear_acceleration.x > 0.5):
    move.angular.x = imu_data.linear_acceleration.x / 10
  twist_pub.publish(move)	

if __name__ == '__main__':
  '''Initializes and cleanup ros node'''
  rospy.init_node('mobile_drive', anonymous=True)
  twist_pub = rospy.Publisher("/fake_nav/drive",Twist)
  imu_subsc = rospy.Subscriber("/imu",Imu, callback, queue_size = 1)
  try:
     rospy.spin()
  except KeyboardInterrupt:
     print "Shutting down ROS module"

